<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Log;

class MetafieldsController extends Controller {

    public function __construct() {
  
      }

    /**
     * Get metafields
     */
    public function getMetafields(Request $request) {

        $shop = Auth::user();
        $limit = 250;
        $pid = !empty($request->input('pid')) ? trim($request->input('pid')) : "";
        $result = $shop->api()->rest('GET', '/admin/products/'.$pid.'/metafields.json',["limit" => $limit]);
        $result = (object)$result;
        $metafields = $result->body->metafields;
        $html = '<tr class="Polaris-DataTable__TableRow addnew-row"><td colspan="4">
        <div class="Polaris-Card">
            <div class="Polaris-Card__Header">
            </div>
            <div class="Polaris-Card__Section">
                <table class="Polaris-DataTable__Table tbl-metafields">
                <thead>
                  <tr><th data-polaris-header-cell="true" class="Polaris-DataTable__Cell Polaris-DataTable__Cell--verticalAlignTop Polaris-DataTable__Cell--firstColumn Polaris-DataTable__Cell--header" scope="col">Metafield</th>
                  <th data-polaris-header-cell="true" class="Polaris-DataTable__Cell Polaris-DataTable__Cell--verticalAlignTop Polaris-DataTable__Cell--firstColumn Polaris-DataTable__Cell--header" scope="col">Value</th>
                  <th data-polaris-header-cell="true" class="Polaris-DataTable__Cell Polaris-DataTable__Cell--verticalAlignTop Polaris-DataTable__Cell--header Polaris-DataTable__Cell--firstColumn" scope="col">Action</th></tr>
                  </thead><tbody>';

        foreach ($metafields as $meta) {

            $html = $html.'<tr meta-id="'.$meta->id.'" class="meta-row Polaris-DataTable__TableRow"> <td class="Polaris-DataTable__Cell Polaris-DataTable__Cell--firstColumn" scope="row">'.
            $meta->namespace.'.'.$meta->key.'</td><td class="td-meta-val Polaris-DataTable__Cell Polaris-DataTable__Cell--firstColumn" scope="row">'.$meta->value.'</td><td class="Polaris-DataTable__Cell Polaris-DataTable__Cell--firstColumn" scope="row">
            <a class="edit_meta astyle" meta_id="'.$meta->id.'" product_id="'.$pid.'"><i title="edit" class="fa fa-edit"></i></a>&nbsp;&nbsp;&nbsp;&nbsp;<a class="delete_meta astyle" meta_id="'.
            $meta->id.'" product_id="'.$pid.'"><i title="delete" class="fa fa-trash"></i></a></td></tr>';
        }

        $html = $html.'</tbody></table>
            </div>
            <div class="Polaris-ButtonGroup">
                <div class="Polaris-ButtonGroup__Item"><button attr-pid="'.$pid.'" type="button" class="Polaris-Button Polaris-Button--primary add-new"><span class="Polaris-Button__Content"><span class="Polaris-Button__Text">Add Metafield</span></span></button></div>
            </div>
            </div>
        </div></td</tr>';

        echo $html;
    }

    /**
     * Get variant metafields
     */
    public function getVariantMetafields(Request $request) {

        $shop = Auth::user();
        $pid = !empty($request->input('pid')) ? trim($request->input('pid')) : "";
        $vid = !empty($request->input('vid')) ? trim($request->input('vid')) : "";
        $limit = 250;
        $result = $shop->api()->rest('GET', '/admin/products/'.$pid.'/variants/'.$vid.'/metafields.json',["limit" => $limit]);
        $result = (object)$result;
        $metafields = $result->body->metafields;
        $html = '<tr class="Polaris-DataTable__TableRow addnew-row"><td colspan="4">
        <div class="Polaris-Card">
            <div class="Polaris-Card__Header">
            </div>
            <div class="Polaris-Card__Section">
                <table class="Polaris-DataTable__Table tbl-metafields">
                <thead>
                  <tr><th data-polaris-header-cell="true" class="Polaris-DataTable__Cell Polaris-DataTable__Cell--verticalAlignTop Polaris-DataTable__Cell--firstColumn Polaris-DataTable__Cell--header" scope="col">Metafield</th>
                  <th data-polaris-header-cell="true" class="Polaris-DataTable__Cell Polaris-DataTable__Cell--verticalAlignTop Polaris-DataTable__Cell--firstColumn Polaris-DataTable__Cell--header" scope="col">Value</th>
                  <th data-polaris-header-cell="true" class="Polaris-DataTable__Cell Polaris-DataTable__Cell--verticalAlignTop Polaris-DataTable__Cell--header Polaris-DataTable__Cell--firstColumn" scope="col">Action</th></tr>
                  </thead><tbody>';

        foreach ($metafields as $meta) {

            $html = $html.'<tr meta-id="'.$meta->id.'" class="meta-row Polaris-DataTable__TableRow"> <td class="Polaris-DataTable__Cell Polaris-DataTable__Cell--firstColumn" scope="row">'.
            $meta->namespace.'.'.$meta->key.'</td><td class="td-meta-val Polaris-DataTable__Cell Polaris-DataTable__Cell--firstColumn" scope="row">'.$meta->value.'</td><td class="Polaris-DataTable__Cell Polaris-DataTable__Cell--firstColumn" scope="row">
            <a class="edit_meta astyle" meta_id="'.$meta->id.'" product_id="'.$pid.'" variant_id="'.$vid.'"><i title="edit" class="fa fa-edit"></i></a>&nbsp;&nbsp;&nbsp;&nbsp;<a class="delete_meta astyle" meta_id="'.
            $meta->id.'" product_id="'.$pid.'"><i title="delete" class="fa fa-trash"></i></a></td></tr>';
        }

        $html= $html.'</tbody></table>
            </div>
            <div class="Polaris-ButtonGroup">
                <div class="Polaris-ButtonGroup__Item"><button attr-pid="'.$pid.'" attr-vid="'.$vid.'" type="button" class="Polaris-Button Polaris-Button--primary add-new-variant"><span class="Polaris-Button__Content"><span class="Polaris-Button__Text">Add Metafield</span></span></button></div>
            </div>
            </div>
        </div></td</tr>';

        echo $html;
    }

    /**
     * Add metafield to products
     */
    public function addmetafield(Request $request) {

        $shop = Auth::user();
        $p_id = !empty($request->input('p_id')) ? trim($request->input('p_id')) : "";
        $meta_name = !empty($request->input('meta_name')) ? trim($request->input('meta_name')) : "";
        $meta_key = !empty($request->input('meta_key')) ? trim($request->input('meta_key')) : "";
        $meta_val = !empty($request->input('meta_val')) ? trim($request->input('meta_val')) : "";
        $data = ["metafield" => ["namespace"=>$meta_name, "key" => $meta_key, "value" => $meta_val, "type" => "multi_line_text_field"]];
        $result = $shop->api()->rest('POST', '/admin/products/'.$p_id.'/metafields.json',$data);
        $result = (object)$result;
        echo json_encode($result->body);
    }

    /**
     * Add metafield to product variants
     */
    public function addvariantmetafield(Request $request) {

        $shop = Auth::user();
        $p_id = !empty($request->input('p_id')) ? trim($request->input('p_id')) : "";
        $v_id = !empty($request->input('v_id')) ? trim($request->input('v_id')) : "";
        $meta_name = !empty($request->input('meta_name')) ? trim($request->input('meta_name')) : "";
        $meta_key = !empty($request->input('meta_key')) ? trim($request->input('meta_key')) : "";
        $meta_val = !empty($request->input('meta_val')) ? trim($request->input('meta_val')) : "";
        $data = ["metafield" => ["namespace"=>$meta_name, "key" => $meta_key, "value" => $meta_val, "type" => "multi_line_text_field"]];
        $result = $shop->api()->rest('POST', '/admin/products/'.$p_id.'/variants/'.$v_id.'/metafields.json',$data);
        $result = (object)$result;
        echo json_encode($result->body);
    }

    /**
     * Get metafield by Id
     */
    public function getMetafield(Request $request) {

        $shop = Auth::user();
        $mid = !empty($request->input('mid')) ? trim($request->input('mid')) : "";
        $result = $shop->api()->rest('GET', '/admin/metafields/'.$mid.'.json');
        $result = (object)$result;
        echo json_encode($result->body);
    }

    /**
     * Delete metafield by Id
     */
    public function deleteMetafield(Request $request) {

        $shop = Auth::user();
        $mid = !empty($request->input('mid')) ? trim($request->input('mid')) : "";
        $result = $shop->api()->rest('DELETE', '/admin/metafields/'.$mid.'.json');
        $result = (object)$result;
        echo json_encode($result->body);
    }

    /**
     * Update metafield by Id
     */
    public function updateMetafield(Request $request) {

        $shop = Auth::user();
        $mid = !empty($request->input('mid')) ? trim($request->input('mid')) : "";
        $mval = !empty($request->input('meta_val')) ? trim($request->input('meta_val')) : "";
        $data = ["metafield"=>["id" => $mid, "value" => $mval]];
        $result = $shop->api()->rest('PUT', '/admin/metafields/'.$mid.'.json',$data);
        $result = (object)$result;
        echo json_encode($result->body);
    }

}
